module TalltyImportExport
  class ExportForm < TalltyImportExport::Export
    def initialize
      super({})
    end

    class << self
      def form_transfer_to_headers form

      end
    end

    def export_workbook workbook, association_records, **options
      # excel导出样式

      # alignment = { vertical: :center, horizontal: :center }
      # border    = { color: '969696', style: :thin }
      # title1 = workbook.styles.add_style(alignment: alignment, border: border, sz: 12, b: true)
      # title2 = workbook.styles.add_style(alignment: alignment, border: border, bg_color: "2a5caa",  sz: 12, fg_color: "fffffb")
      # title3 = workbook.styles.add_style(alignment: alignment.merge(wrap_text: true), border: border, sz: 10)
      headers = export_headers_result **options

      p headers.flatten_value.map(&:key)

      # _sheet_name = respond_to?(:sheet_name) ? self.sheet_name : nil

      # workbook.add_worksheet(name: _sheet_name) do |sheet|
      #   if respond_to?(:first_header)
      #     row_index = Axlsx.col_ref(headers.size - 1)
      #     sheet.merge_cells("A1:#{row_index}1")
      #     sheet.add_row [first_header], style: title1, height: 30
      #   end

      #   sheet.add_row headers.map{|header| header[:name]}, style: title2, height: 25

      #   last_row = nil
      #   merge_column_hash = {}
      #   first_content_row_index = respond_to?(:first_header) ? 2 : 1

        index = 0
        association_records.each do |association_record|
          records = @each_method.present? ?
            (try_method(association_record, @each_method) || [nil]) :
            [association_record]

          records.each do |record|
            row = []
            formats = []
            index += 1

            lines = TalltyImportExport::ExportPayload.new(record, headers: headers) do |payload, header|
              # p "payload: #{payload} -- header[:key]  #{header[:key]}"
              _data = header[:source] ?
                handle_data(association_record, header, index) :
                handle_data(payload, header, index)
            end.lines

            result = []

            lines.transpose.map do |transposed_line|
              line = transposed_line
              while line[0].nil?
                line.shift
                line.push(false)
              end
              line
              # transposed_line.compact
            end.transpose.each do |line|

              if line.select(&:itself).count > 0
                result << line.map { |x| x || '________' }
              end
            end

            # result = []
            # cache[0].length.times do
            #   cache.each_with_index do |line, index|
            #     result[index] = [] unless result[index]
            #     result[index] << line[index]
            #   end
            # end
p '----------------------------------------------------------------'
          result.uniq.sort.each { |x| p x }





            # headers.each_with_index do |header, col_index|
            #   _data = header[:source] ?
            #     handle_data(association_record, header, index) :
            #     handle_data(record, header, index)

            #   if header[:merge].present? && last_row.present? && _data == last_row[col_index]
            #     # 这里使用二维数组，每个数组里都是列内容相同的各行
            #     merge_column_hash[col_index] ||= []
            #     if merge_column_hash[col_index].last&.last == index + first_content_row_index - 1
            #       # 说明内容和上面的是延续的，继续加入之前的数组
            #       merge_column_hash[col_index].last << index + first_content_row_index
            #     else
            #       merge_column_hash[col_index] << [index + first_content_row_index - 1, index + first_content_row_index]
            #     end
            #   end
            #   row.push(_data)
            #   formats.push(header[:format]&.to_sym || (_data.is_a?(String) ? :string : nil))
            # end
            # sheet.add_row row, style: title3, height: @row_height, types: formats
            # last_row = row
          end
        end
      #   # 需要根据column进行多行的内容合并
      #   if merge_column_hash.present?
      #     merge_column_hash.each do |col_index, row_arr|
      #       row_arr.each do |arr|
      #         sheet.merge_cells(
      #           Axlsx::cell_r(col_index, arr.first) + ':' + Axlsx::cell_r(col_index, arr.last)
      #         )
      #       end
      #     end
      #   end
      #   sheet.column_widths(*headers.map{|header| (header[:width] || @width).to_f})
      # end
    end


    def export_headers_result **options
      @headers = options[:headers]
      super(**options)
      @headers = TalltyImportExport::Attr::ExportHeader.new({ items: @headers })
    end

  end
end
